 OEOP:=module()
 global OEOP,main1;
 local De_operator,
       chang_var,
       Approx_odd_nth,
       Approx_even_nth,
       sol_analy,
       conti_odd,
       conti_even,
       conti_higher,
       conti_hcurve,
       pw_pade,
       pw_delta_pade,
       INFO;
       
 option package;
 _EnvAllSolutions:=true: 
 _EnvExplicit:=true:
 plotsetup(default):
 
################## the main function #############################################################################
   main1:=proc(eq,ini_list::list) 
   local eq1,eq2,eq3,pp,pp1,pp2,tt,j,pset,pset1,t_set,deg_set,para_set;
   INFO("start_t"):=time();
   INFO("horder"):=8;
   INFO("solorder"):=10;
   if nargs=3 then 
       INFO("horder"):=args[3];
       INFO("solorder"):=INFO("horder")+2;
   elif nargs=4 then
       INFO("horder"):=args[3];
       INFO("solorder"):=args[4];
   end if:
   printf(`The input equation & initial conditions are:\n`);
   print(eq);
   print(ini_list);
   para_set:=indets(eq) union indets(ini_list);
   INFO("para_set2"):=select(type,para_set,name) minus {delta};
   eq1:=numer(simplify(expand(lhs(eq)-rhs(eq))));
   pp:=sort([op(eq1)],`length`);
   pp1:=select(type,pp,function);
   if pp1<>[] then
     tt:=op(1,pp1);
   else
     pp2:={};
     for j from 1 to nops(pp) do
        if type(op(j,pp),`*`) or type(op(j,pp),`^`) then
            pp2:=pp2 union {op(op(j,pp))};
            if select(type,pp2,function)<>{} then
               tt:=op(1,select(type,pp2,function));
            end if;
         end if;
     end do:
   end if:
   if has(tt,diff) then
     INFO("zvar"):=op(2,tt);
     pset1:={op(tt)} minus {INFO("zvar")};
     pset:=select(has,pset1,diff);
     while(pset<>{}) do
        pset1:={op(op(1,pset))} minus {INFO("zvar")};
        pset:=select(has,pset1,diff);
     end do:
     INFO("fname"):=op(pset1);
   else
     INFO("zvar"):=op(1,tt);
     INFO("fname"):=tt;
   end if:
 ##the following is to judge the odd oscillation or even oscillation?
   eq2:=collect(combine(expand(subs(INFO("fname")=a*cos(INFO("zvar")),eq1))),cos);
   eq3:=remove(has,eq2,cos);
   if eq3<>0 then
      INFO("podd"):=2;
   else
      INFO("podd"):=3;
   end if:
   INFO("para_set2"):=INFO("para_set2") minus {INFO("zvar")};
   chang_var(eq1,ini_list);
 end proc:
##################################################################################################################

################## Define linear and nonlinear operator ##########################################################
 De_operator:=proc(eq)
    global Know_u,Know_omega,Know_delta,Pade_omega,Pade_delta;
    Know_u:={u[0](tau)=INFO("ini_val")*cos(tau)};
    Know_omega:=[];
    Know_delta:=[];
    Pade_omega:={};
    Pade_delta:={};
    INFO("Lop"):=x->omega[0]^2*(Diff(x,tau$2)+x);
    INFO("Nop"):=simplify(algsubs(u(tau)=Phi(tau,q),eq));
    INFO("Nop"):=simplify(algsubs(omega=omega(q),INFO("Nop")));
    if INFO("podd") mod 2=0 then
       INFO("Nop"):=simplify(algsubs(delta=delta(q),INFO("Nop")));
    end if:
    undefine(G);
    define(G,G(a::algebraic*cos(b::nonunit(integer)*tau::name))=-1/omega[0]^2*a*cos(b*tau)/(b^2-1), 
    G(a::algebraic)=a/omega[0]^2); 
    INFO("p1"):=u[0](tau);
    INFO("q1"):=0;
    INFO("d1"):=0;
    INFO("R")[mm]:=h*1/(mm-1)!*Diff(INFO("Nop"),q$(mm-1));
    if INFO("podd") mod 2<>0 then
       Approx_odd_nth();
    else
       Approx_even_nth();
    end if:
  end proc:
  Losinv:=proc(exp,L)
         if type(exp,`+`) then 
              map(L,exp) 
         else L(exp) 
         end if: 
    end proc:
##################################################################################################################
  
####################### change var proc ########################################################################## 
 chang_var:=proc(eq,ini_list::list)
  local eq3,new_ini,Diff_ini_list;
  INFO("eq2"):=simplify(dsubs(diff(INFO("fname"),INFO("zvar")$2)=diff(u(tau),tau$2)*omega^2,eq));
  INFO("eq2"):=simplify(dsubs(diff(INFO("fname"),INFO("zvar"))=diff(u(tau),tau)*omega,INFO("eq2")));
  if INFO("podd") mod 2<>0 then
     INFO("eq2"):=simplify(subs(INFO("fname")=u(tau),INFO("eq2")));
     INFO("eq2"):=simplify(subs(omega*t=tau,INFO("eq2")));
     INFO("eq2"):=simplify(algsubs(t=tau/omega,INFO("eq2")));
  else
     INFO("eq2"):=simplify(subs(INFO("fname")=u(tau)+delta,INFO("eq2")));
     INFO("eq2"):=simplify(subs(omega*t=tau,INFO("eq2")));
     INFO("eq2"):=simplify(algsubs(t=tau/omega,INFO("eq2")));
  end if:
  new_ini:=simplify(subs(INFO("zvar")=0,delta=0,ini_list));
  Diff_ini_list:=convert(new_ini,Diff);
  INFO("ini_val"):=rhs(op(1,remove(has,Diff_ini_list,Diff)));
  new_ini:=simplify(subs(op(0,INFO("fname"))=u,new_ini));
  printf(`The new EQ & initial conditions in u with the form: \n`);
  print(INFO("eq2"));
  print(new_ini);
  printf("where:");
  if INFO("podd") mod 2<>0 then
     print(tau=omega*t, INFO("fname")=u(tau) );
  else
     print(tau=omega*t, INFO("fname")=u(tau)+\delta );
  end if:
  De_operator(INFO("eq2"));
 end proc:
##################################################################################################################

##########################The nth approximant of odd oscillation  ################################################
 ## Approx_odd_nth is to compute the nth-order approximation by the HAM(odd oscillation).
 Approx_odd_nth:=proc()
  global Know_u,Know_omega;
  local p11,q11,rhigh,w_eq,w_sol,rhigh_list,i,j,ij,rhighn,rhighd,high_eq,sol_list,sol1,sol2,r_sol,solu,
  terp,term,cos_term,cos_coeff,mp1,tmp,tmp1,tmp2;
  for i from 1 to INFO("horder") do
    if i=1 then
      INFO("R")[i]:=h*INFO("Nop");
    else
      INFO("R")[i]:=subs(mm=i,INFO("R")[mm]);
      INFO("R")[i]:=simplify(INFO("R")[i]);
    end if;
    INFO("p1"):=INFO("p1")+u[i](tau)*q^i;
    INFO("q1"):=INFO("q1")+omega[i-1]*q^(i-1);
    p11:=Phi(tau,q)=INFO("p1");
    q11:=omega(q)=INFO("q1");
    INFO("R")[i]:=simplify(subs(p11,INFO("R")[i]));
    INFO("R")[i]:=simplify(subs(q11,INFO("R")[i]));
    INFO("R")[i]:=value(INFO("R")[i]):
    INFO("R")[i]:=convert(INFO("R")[i],diff):
    INFO("R")[i]:=simplify(subs(q=0,INFO("R")[i]));
    if i=1 then
      rhigh:=INFO("R")[i];
    else
      rhigh:=INFO("R")[i]+INFO("Lop")(u[i-1](tau));
    end if;
    rhigh:=simplify(subs(Know_u,rhigh));
    rhigh:=expand(rhigh);
    rhigh:=collect(combine(rhigh),cos);
    w_eq:=coeff(rhigh,cos(tau));
    rhigh:=rhigh-w_eq*cos(tau);
    rhigh:=expand(simplify(combine(rhigh)));
    w_sol:={solve(w_eq,omega[i-1])};
    w_sol:=remove(has,w_sol,I);
    if w_sol={} then
        printf("Error, no positive frequency w!");
        return;
    end if:
    if i=1 then
       for ij from 1 to nops(w_sol) do
         if sign(evalf(op(ij,w_sol)))=1 then
                   tmp:=op(ij,w_sol);
                   break;
         end if:
       end do:
    else
       tmp:=op(1,w_sol);
    end if:
    Know_omega:=[op(Know_omega),omega[i-1]=tmp];
    rhighn:=collect(combine(numer(rhigh)),cos);
    rhighd:=denom(rhigh);
    va1:=Losinv(rhighn,G);
    solu:=va1/rhighd;
    solu:=solu+_C1*cos(tau);
    tmp1:=simplify(subs(tau=0,solu)):
    #tmp2:=simplify(subs(tau=Pi,solu)):
    #tmp:=solve(tmp1-tmp2=0,select(has, indets(tmp1),{_C1}));
    tmp:=solve(tmp1=0,select(has, indets(tmp1),{_C1}));
    solu:=u[i](tau)=collect(combine(simplify(subs(tmp,solu))),cos);
    Know_u:=Know_u union {solu};
  end do:
  INFO("fcomput_t"):=time()-INFO("start_t");
  printf("It takes about %.3f seconds to complete the first part computation.\n",INFO("fcomput_t"));
  sol_analy();
 end proc:
##################################################################################################################

##########################The nth approximant of quadratic oscillation ###########################################
 Approx_even_nth:=proc()
  global Know_u,Know_omega,Know_delta;
  local p11,q11,d11,rhigh,rnumer,rdenom,nu_cbine,w_eq,w_sol,rhigh_list,delta_sol,delta_eq,i,j,high_eq,tmp1,tmp2,
  sol_list,sol1,sol2,r_sol,solu,rhighn,rhighd,ij,terp,term,cos_term,cos_coeff,mp1,tmp;
  for i from 1 to INFO("horder") do
   if i=1 then
      INFO("R")[i]:=simplify(subs(mm=i,INFO("R")[mm]));
   else
      INFO("R")[i]:=subs(mm=i,INFO("R")[mm]);
   end if;
   INFO("R")[i]:=value(INFO("R")[i]):
   INFO("p1"):=INFO("p1")+u[i](tau)*q^i;
   INFO("q1"):=INFO("q1")+omega[i-1]*q^(i-1);
   INFO("d1"):=INFO("d1")+delta[i-1]*q^(i-1);
   p11:=Phi(tau,q)=INFO("p1");
   q11:=omega(q)=INFO("q1");
   d11:=delta(q)=INFO("d1");
   INFO("R")[i]:=simplify(subs(p11,INFO("R")[i]));
   INFO("R")[i]:=simplify(subs(q11,INFO("R")[i]));
   INFO("R")[i]:=simplify(subs(d11,INFO("R")[i]));
   INFO("R")[i]:=value(INFO("R")[i]):
   INFO("R")[i]:=convert(INFO("R")[i],diff):
   INFO("R")[i]:=simplify(subs(q=0,INFO("R")[i]));
   if i=1 then
      rhigh:=INFO("R")[i];
   else
      rhigh:=INFO("R")[i]+INFO("Lop")(u[i-1](tau));
   end if;
   rhigh:=simplify(subs(Know_u,rhigh));
   rhigh:=expand(rhigh);
   rhigh:=collect(combine(rhigh),cos);
   w_eq:=coeff(rhigh,cos(tau));
   rnumer:=numer(rhigh);
   rdenom:=denom(rhigh);
   nu_cbine:=collect(combine(rnumer),cos);
   delta_eq:=remove(has,nu_cbine,cos);
   rhigh:=collect(combine(simplify(rhigh-w_eq*cos(tau)-delta_eq/rdenom)),cos);
   if has(delta_eq,delta[i-1]) then
       w_sol:={solve(w_eq,omega[i-1])};
       w_sol:=remove(has,w_sol,I);
       delta_sol:={solve(delta_eq,delta[i-1])};
       if INFO("podd")>=3 then
           delta_sol:=evalf(delta_sol):
       end if:
   else
     tmp:=solve({w_eq,delta_eq},{omega[i-1],delta[i-1]});
     w_sol:=select(has,tmp,omega[i-1]);
     delta_sol:=remove(has,tmp,omega[i-1]);
     w_sol:=map(i->rhs(i),w_sol);
     delta_sol:=map(i->rhs(i),delta_sol);
   end if:  
   if hastype(w_sol,RootOf) then
      w_sol:=convert(w_sol,radical);
   end if: 
   delta_sol:=remove(has,delta_sol,I);
 ##w[0] should be positive
   if i=1 then
      for ij from 1 to nops(w_sol) do
         if sign(evalf(op(ij,w_sol)))=1 then
               tmp:=op(ij,w_sol);
               break;
         end if:
      end do:
      if hastype(tmp,sqrt) then
         for ij from 1 to nops(delta_sol) do
             tmp1:=op(ij,delta_sol):
             tmp2:=evalf(eval(tmp,delta[i-1]=tmp1)):
             if not has(tmp2,I) then
                break;
             end if
         end do:
      end if:
   else
      tmp:=op(1,w_sol):
      tmp1:=op(1,delta_sol):
   end if:
   Know_omega:=[op(Know_omega),omega[i-1]=tmp];
   Know_delta:=[op(Know_delta),delta[i-1]=tmp1];
   rhighn:=collect(combine(numer(rhigh)),cos);
   rhighd:=denom(rhigh);
   va1:=Losinv(rhighn,G);
   solu:=va1/rhighd;
   solu:=solu+_C1*cos(tau);
   tmp1:=simplify(subs(tau=0,solu)):
  # tmp2:=simplify(subs(tau=Pi,solu)):
   tmp:=solve(tmp1=0,select(has, indets(tmp1),{_C1}));
   solu:=u[i](tau)=collect(combine(simplify(subs(tmp,solu))),cos);
   Know_u:=Know_u union {solu};
 end do:
 INFO("fcomput_t"):=time()-INFO("start_t");
 printf("It takes about %.3f seconds to complete the first part computation.\n",INFO("fcomput_t"));
 sol_analy();
end proc:
##################################################################################################################
 
#######################Pade technique ############################################################################ 
pw_pade:=proc(Know_w2::set)
  global Pade_omega;
  local j,w_pade_set,w_pade_set2,pp,tmp,tmp1,jj,draw_con,draw_interval,draw_interval2,draw_left,draw_right,
  con1,con2,con3,con4,con5,con6;
  w_pade_set:={};
  for j from 1 to (nops(Know_w2)-1)/2 do
    w_pade_set:=w_pade_set union {omega[P[j,j]]=simplify(subs(h=-1,op(j,INFO("w_pade"))))};
 end do:
 tmp:=convert(Know_w2,radical):
 w_pade_set2:=convert(simplify(subs(tmp,w_pade_set)),radical);
 Pade_omega:=w_pade_set2;
 for j from 1 to nops(w_pade_set2) do
    print(op(j,w_pade_set2));
 end do:
 if nops(INFO("para_set2"))=1 then
    jup:=min(3,nops(w_pade_set2)):
    con1:=indets(rhs(op(1,w_pade_set2))):   
    con2:=convert(sort(con1,length),list):
    con3:=select(type,con2,radical):
    if con3<>[] then
       con4:={};
       for ij from 1 to nops(con3) do
            con4:=con4 union {op(op(ij,con3))};
       end do:
       con5:=remove(type,con4,fraction);
       con6:=1;
       for ij from 1 to nops(con5) do
           con6:=con6*op(ij,con5);
       end do:
       tmp:=convert({solve({con6>0},op(1,INFO("para_set2")))},radical):
  # print("tmp=",tmp);    
        tmp:=op(1,tmp);
        if type(op(1,tmp),`=`) then
            tmp:={op(1,INFO("para_set2"))>-100,op(1,INFO("para_set2"))<100};
        end if:
    else
        tmp:={op(1,INFO("para_set2"))>-100,op(1,INFO("para_set2"))<100};
    end if:    
    draw_interval:={solve({op(tmp),denom(rhs(op(1,w_pade_set2)))<>0},op(1,INFO("para_set2")))};
    draw_interval:=convert(draw_interval,radical);
    draw_interval2:=1;
    if nops(draw_interval)>1 then
        for j from 1 to nops(draw_interval) do
            if nops(op(j,draw_interval))=1 then
                draw_interval2:=op(j,draw_interval);
            end if:
        end do:
        if draw_interval2=1 then
           draw_interval2:=op(1,draw_interval);
        end if:
     else
        draw_interval2:=op(1,draw_interval);
     end if:
     draw_interval:=draw_interval2;
     if nops(draw_interval)=1 then
         if type(op(draw_interval),`<`) then
            if type(op(1,op(draw_interval)),name) then
               draw_left:=op(2,op(draw_interval))-1000;
               draw_right:=op(2,op(draw_interval));
            else
               draw_left:=op(1,op(draw_interval));
               draw_right:=op(1,op(draw_interval))+1000;
            end if:   
         else 
            if type(op(1,op(draw_interval)),name) then
               draw_left:=op(2,op(draw_interval));
               draw_right:=op(2,op(draw_interval))+1000;
            else
               draw_left:=op(1,op(draw_interval))-1000;
               draw_right:=op(1,op(draw_interval));
            end if:
         end if:   
         draw_left:=evalf(draw_left):
         draw_right:=evalf(draw_right):
     else
         tmp1:=op(remove(type, {op(op(1,draw_interval))},name));
         tmp2:=op(remove(type, {op(op(2,draw_interval))},name));
         if evalb(evalf(tmp1<tmp2)) then
            draw_left:=tmp1;
            draw_right:=tmp2;
         else
            draw_left:=tmp2;
            draw_right:=tmp1;
         end if:
         draw_left:=evalf(draw_left+0.1);
         draw_right:=evalf(draw_right-0.1);
     end if:  
    if type(evalf(draw_left),{integer,float}) and type(evalf(draw_right),{integer,float}) then  
      pp_list:=[];
      pp_style:=[[style=point, symbol=asterisk, color=blue],[style=line, color=red],[style=point, symbol=circle, color=black]];
      r:=nops(w_pade_set2);
      for j from r by -1 to r-jup+1 do
        if j=r then
           pp[j]:=plot(rhs(op(j,w_pade_set2)),op(1,INFO("para_set2"))=draw_left..draw_right, op(op(1,pp_style)),legend=["\omega_p[r,r]"]);        elif j=r-1 then 
           pp[j]:=plot(rhs(op(j,w_pade_set2)),op(1,INFO("para_set2"))=draw_left..draw_right, op(op(2,pp_style)),legend=["\omega_p[r-1,r-1]"]);
        elif j=r-2 then
           pp[j]:=plot(rhs(op(j,w_pade_set2)),op(1,INFO("para_set2"))=draw_left..draw_right, op(op(3,pp_style)),legend=["\omega_p[r-2,r-2]"]);
        end if:
        pp_list:=[pp[j],op(pp_list)];
      end do:
      print(display(pp_list,title=`The Pade approximants of \omega`));
      printf("where: r=%d.\n",r);
   else
      printf("Error, no real drawing interval for %a.\n",op(1,INFO("para_set2")));
   end if:
 end if:
 end proc:

 pw_delta_pade:=proc(Know_w2,Know_delta2)
 global Pade_omega,Pade_delta;
 local j,w_pade_set,delta_pade_set,pp,tmp,tmp1,w_pade_set2,delta_pade_set2,draw_con,draw_interval,draw_interval2,
 draw_left,draw_right,con1,con2,con3,con4,con5,con6;
 INFO("delta_pade"):=subs(omega=delta,INFO("w_pade")):
 w_pade_set:={};
 for j from 1 to (nops(Know_w2)-1)/2 do
    w_pade_set:=w_pade_set union {w_pade[j,j]=simplify(subs(h=-1,op(j,INFO("w_pade"))))};
 end do:
 tmp:=convert(Know_w2,radical):
 w_pade_set2:=convert(simplify(subs(tmp,w_pade_set)),radical);
 Pade_omega:=w_pade_set2;
 for j from 1 to nops(w_pade_set2) do
     print(op(j,w_pade_set2));
 end do:
 if nops(INFO("para_set2"))=1 then
    jup:=min(3,nops(w_pade_set2)):
    con1:=indets(rhs(op(1,w_pade_set2))):   
    con2:=convert(sort(con1,length),list):
    con3:=select(type,con2,radical):
    if con3<>[] then 
       con4:={};
       for ij from 1 to nops(con3) do
            con4:=con4 union {op(op(ij,con3))};
       end do:
       con5:=remove(type,con4,fraction);
       con6:=1;
       for ij from 1 to nops(con5) do
           con6:=con6*op(ij,con5);
       end do:
       tmp:=convert({solve({con6>0},op(1,INFO("para_set2")))},radical):
       tmp:=op(1,tmp);
 #print("tmp=",tmp);
       if type(op(1,tmp),`=`) then
            tmp:={op(1,INFO("para_set2"))>-100,op(1,INFO("para_set2"))<100};
       end if:
    else
       tmp:={op(1,INFO("para_set2"))>-100,op(1,INFO("para_set2"))<100};
    end if:   
    draw_interval:={solve({op(tmp),denom(rhs(op(1,w_pade_set2)))<>0},op(1,INFO("para_set2")))};
    draw_interval:=convert(draw_interval,radical);
    draw_interval2:=1;
    if nops(draw_interval)>1 then
        for j from 1 to nops(draw_interval) do
            if nops(op(j,draw_interval))=1 then
                draw_interval2:=op(j,draw_interval);
            end if:
        end do:
        if draw_interval2=1 then
           draw_interval2:=op(1,draw_interval);
        end if:
     else
        draw_interval2:=op(1,draw_interval);
     end if:
     draw_interval:=draw_interval2;
     if nops(draw_interval)=1 then
         if type(op(draw_interval),`<`) then
            if type(op(1,op(draw_interval)),name) then
                 draw_left:=op(2,op(draw_interval))-1000;
                 draw_right:=op(2,op(draw_interval))-1;
            else
                 draw_left:=op(1,op(draw_interval))+1;
                 draw_right:=op(1,op(draw_interval))+1000;
            end if: 
         else 
            if type(op(1,op(draw_interval)),name) then
                 draw_left:=op(2,op(draw_interval))+1;
                 draw_right:=op(2,op(draw_interval))+1000;
            else
                 draw_left:=op(1,op(draw_interval))-1000;
                 draw_right:=op(1,op(draw_interval))-1;
            end if:
         end if:   
         draw_left:=evalf(draw_left):
         draw_right:=evalf(draw_right):
    else
         tmp1:=op(remove(type, {op(op(1,draw_interval))},name));
         tmp2:=op(remove(type, {op(op(2,draw_interval))},name));
         if evalb(evalf(tmp1<tmp2)) then
            draw_left:=tmp1;
            draw_right:=tmp2;
         else
            draw_left:=tmp2;
            draw_right:=tmp1;
         end if:
         draw_left:=evalf(draw_left/2);
         draw_right:=evalf(draw_right/2);
    end if:   
    if type(evalf(draw_left),{integer,float}) and type(evalf(draw_right),{integer,float}) then
      pp_list:=[];
      pp_style:=[[style=point, symbol=asterisk, color=blue],[style=line, color=red],[style=point, symbol=circle, color=black]];
      r:=nops(w_pade_set2);
      for j from r by -1 to r-jup+1 do
       if j=r then
          pp[j]:=plot(rhs(op(j,w_pade_set2)),op(1,INFO("para_set2"))=draw_left..draw_right, op(op(1,pp_style)),legend=["\omega_p[r,r]"]);
       elif j=r-1 then 
          pp[j]:=plot(rhs(op(j,w_pade_set2)),op(1,INFO("para_set2"))=draw_left..draw_right, op(op(2,pp_style)),legend=["\omega_p[r-1,r-1]"]);
       elif j=r-2 then
          pp[j]:=plot(rhs(op(j,w_pade_set2)),op(1,INFO("para_set2"))=draw_left..draw_right, op(op(3,pp_style)),legend=["\omega_p[r-2,r-2]"]);
       end if:  
         pp_list:=[pp[j],op(pp_list)];
      end do:
      print(display(pp_list,title=`The Pade approximants of \omega`));
     else
      printf("Error, no real drawing interval for %c.\n",op(1,INFO("para_set2")));
     end if:
 end if:
 printf("\n");
 delta_pade_set:={};
 j:='j';
 for j from 1 to (nops(Know_w2)-1)/2 do
    delta_pade_set:=delta_pade_set union {delta_pade[j,j]=simplify(subs(h=-1,op(j,INFO("delta_pade"))))};
 end do:
 tmp:=convert(Know_delta2,radical):
 delta_pade_set2:=convert(simplify(subs(tmp,delta_pade_set)),radical);
 Pade_delta:=delta_pade_set2;
 for j from 1 to nops(delta_pade_set2) do
     print(op(j,delta_pade_set2));
 end do:
 if nops(INFO("para_set2"))=1 then
    jup:=min(3,nops(delta_pade_set2)):
    con1:=indets(rhs(op(1,delta_pade_set2))):   
    con2:=convert(sort(con1,length),list):
    con3:=select(type,con2,radical):
    if con3<>[] then
        con4:={};
        for ij from 1 to nops(con3) do
            con4:=con4 union {op(op(ij,con3))};
        end do:
        con5:=remove(type,con4,fraction);
        con6:=1;
        for ij from 1 to nops(con5) do
             con6:=con6*op(ij,con5);
        end do:
        tmp:=convert({solve({con6>0},op(1,INFO("para_set2")))},radical):
        tmp:=op(1,tmp);
#print("Atmp=",tmp);
        if type(op(1,tmp),`=`) then
           tmp:={op(1,INFO("para_set2"))>-100,op(1,INFO("para_set2"))<100}:
        end if:
    else
         tmp:={op(1,INFO("para_set2"))>-100,op(1,INFO("para_set2"))<100}:
    end if:
    draw_interval:={solve({op(tmp),denom(rhs(op(1,delta_pade_set2)))<>0},op(1,INFO("para_set2")))};
    draw_interval:=convert(draw_interval,radical);
    draw_interval2:=1;
    if nops(draw_interval)>1 then
        for j from 1 to nops(draw_interval) do
            if nops(op(j,draw_interval))=1 then
                draw_interval2:=op(j,draw_interval);
            end if:
        end do:
        if draw_interval2=1 then
           draw_interval2:=op(1,draw_interval);
        end if:
     else
        draw_interval2:=op(1,draw_interval);
     end if:
    draw_interval:=draw_interval2;
    if nops(draw_interval)=1 then
         if type(op(draw_interval),`<`) then
            if type(op(1,op(draw_interval)),name) then
                 draw_left:=op(2,op(draw_interval))-1000;
                 draw_right:=op(2,op(draw_interval))-1;
            else
                 draw_left:=op(1,op(draw_interval))+1;
                 draw_right:=op(1,op(draw_interval))+1000;
            end if:
         else 
            if type(op(1,op(draw_interval)),name) then
                 draw_left:=op(2,op(draw_interval))+1;
                 draw_right:=op(2,op(draw_interval))+1000;
            else
                 draw_left:=op(1,op(draw_interval))-1000;
                 draw_right:=op(1,op(draw_interval))-1;
            end if:
         end if: 
         draw_left:=evalf(draw_left):
         draw_right:=evalf(draw_right):
   else
         tmp1:=op(remove(type, {op(op(1,draw_interval))},name));
         tmp2:=op(remove(type, {op(op(2,draw_interval))},name));
         if evalb(evalf(tmp1<tmp2)) then
            draw_left:=tmp1;
            draw_right:=tmp2;
         else
            draw_left:=tmp2;
            draw_right:=tmp1;
         end if:
         draw_left:=evalf(draw_left/2);
         draw_right:=evalf(draw_right/2);
    end if:  
    if type(evalf(draw_left),{integer,float}) and type(evalf(draw_right),{integer,float}) then
      pp_list:=[];
      pp_style:=[[style=point, symbol=asterisk, color=blue],[style=line, color=red],[style=point, symbol=circle, color=black]];
      r:=nops(delta_pade_set2):
      for j from r by -1 to r-jup+1 do
        if j=r then
         pp[j]:=plot(rhs(op(j,delta_pade_set2)),op(1,INFO("para_set2"))=draw_left..draw_right, op(op(1,pp_style)),legend=["\delta_p[r,r]"]);
        elif j=r-1 then
         pp[j]:=plot(rhs(op(j,delta_pade_set2)),op(1,INFO("para_set2"))=draw_left..draw_right, op(op(2,pp_style)),legend=["\delta_p[r-1,r-1]"]);
        elif j=r-2 then
         pp[j]:=plot(rhs(op(j,delta_pade_set2)),op(1,INFO("para_set2"))=draw_left..draw_right, op(op(3,pp_style)),legend=["\delta_p[r-2,r-2]"]);
        end if:
        pp_list:=[pp[j],op(pp_list)];
     end do:
         print(display(pp_list,title=`The Pade approximants of \delta`));
         printf("where: r=%d.\n",r);
    else
       printf("Error, no real drawing interval for %c.\n",op(1,INFO("para_set2")));
    end if:
 end if:
end proc:
##############################The end of Pade technique############################################################

############################# Determine h and normal solution expression ##########################################
 sol_analy:=proc()
   global Know_u,Know_omega,Know_delta,Pade_omega,Pade_delta;
   local i,j,k,Know_u1,Know_w1,Know_delta1,flag,roll,randnumer,randdenom,w_delta_0,terp,varss,
   tmp,ij,denom_all,w_delta_1,u_approx,u_approx2,tmp1,tmp2,tmp3,Know_w2,Know_delta2,w_approx,w_approx2,delta_approx,delta_approx2,error_analy,
   error_analy2,error_square,error_square2,int_err_square,int_err_square2,extra_con,extrah,min_val,min_h,now_t,funlist2;
   u_approx:=add(rhs(i),i in Know_u);
   Know_u1:={op(1,Know_u)};
   for ij from 2 to nops(Know_u)-2 do
      Know_u1:=Know_u1 union {op(ij,Know_u)};
   end do:
   u_approx2:=add(rhs(i),i in Know_u1):
   INFO("w_delta0"):={};
   INFO("w_delta0"):=INFO("w_delta0") union {op(1,Know_omega)};
   if INFO("podd") mod 2=0 then
      INFO("w_delta0"):=INFO("w_delta0") union {op(1,Know_delta)};
   end if:
   varss:={lhs(op(1,INFO("w_delta0")))};
   for ij from 2 to nops(INFO("w_delta0")) do
      varss:=varss union {lhs(op(ij,INFO("w_delta0")))};
   end do:
   Know_w1:=convert(Know_omega,set) minus INFO("w_delta0");
   if INFO("podd") mod 2=0 then 
      Know_delta1:=convert(Know_delta,set) minus INFO("w_delta0");
      tmp:=solve(INFO("w_delta0"),varss);
      INFO("w_delta0"):=tmp;
   end if:
   Know_w2:=simplify(subs(INFO("w_delta0"),Know_w1)):
   Know_w1:=solve(Know_w2, select(has,indets(Know_w2),omega)):
   Know_w2:=Know_w1 union select(has,INFO("w_delta0"),omega);
   if INFO("podd") mod 2=0 then
       Know_delta2:=simplify(subs(INFO("w_delta0"),Know_delta1)):
       Know_delta1:=solve(Know_delta2,select(has,indets(Know_delta2),delta)):
       Know_delta2:=Know_delta1 union select(has,INFO("w_delta0"),delta):
   end if:
   vass1:={lhs(op(1,Know_w2))};
   if INFO("podd") mod 2=0 then
       vass2:={lhs(op(1,Know_delta2))};
   end if:
   for ij from 2 to nops(Know_w2) do
     vass1:=vass1 union {lhs(op(ij,Know_w2))};
     if INFO("podd") mod 2=0 then
         vass2:=vass2 union {lhs(op(ij,Know_delta2))};
     end if:
   end do:
   if INFO("podd") mod 2=0 then
     tmp1:=simplify(subs(Know_w2,Know_delta2)):
     tmp2:=simplify(subs(Know_delta2,Know_w2)):
     Know_delta2:=solve(tmp1, vass2):
     Know_w2:=solve(tmp2,vass1):
   end if:
   tmp1:={op(1,Know_w2)}:
   for ij from 2 to nops(Know_w2)-2 do
       tmp1:=tmp1 union {op(ij,Know_w2)};
   end do:
   if INFO("podd") mod 2=0 then
       tmp2:={op(1,Know_delta2)};
       for ij from 2 to nops(Know_delta2)-2 do
           tmp2:=tmp2 union {op(ij,Know_delta2)};
       end do:       
    end if:
   if INFO("podd") mod 2<>0 then
       w_approx:=add(rhs(i),i in Know_w2);
       w_approx2:=add(rhs(i),i in tmp1);
   else
       w_approx:=add(rhs(i), i in Know_w2);
       w_approx2:=add(rhs(i),i in tmp1);
       delta_approx:=add(rhs(i),i in Know_delta2);
       delta_approx2:=add(rhs(i), i in tmp2);
   end if:

###compute w_approx,delta_approx,then substitute them into eq2
 INFO("pade_order"):=1:
 INFO("w_pade"):=[];
 INFO("delta_pade"):=[];
#$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
   if INFO("para_set2")<>{} then
       ptm1:=0;
       for jj from 0 to nops(Know_omega) do
           ptm1:=ptm1+omega[jj]*q^jj;
       end do:
       pade_nps:=(nops(Know_omega)-1)/2;
       for jj from 1 to pade_nps do
          ptm2:=pade(ptm1,q,[jj,jj]):
          ptm3:=eval(ptm2,q=1):
          INFO("w_pade"):=[op(INFO("w_pade")),ptm3];
       end do:
       p_time:=time();
       if INFO("podd") mod 2<>0 then
           pw_pade(Know_w2);
           printf("It takes about %.3f seconds to complete the second part computation.\n",p_time-INFO("fcomput_t")-INFO("start_t"));
           printf("The total time is %.3f seconds.\n",p_time-INFO("start_t"));
           return;
       else
           pw_delta_pade(Know_w2,Know_delta2);
           printf("It takes about %.3f seconds to complete the second part computation.\n",p_time-INFO("fcomput_t")-INFO("start_t"));
           printf("The total time is %.3f seconds.\n",p_time-INFO("start_t"));
           return;
       end if:    
   end if:
#$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
   u_approx:=simplify(subs(Know_w2,u_approx));
   u_approx2:=simplify(subs(tmp1,u_approx2));
   if INFO("podd") mod 2=0 then
      u_approx:=simplify(subs(Know_delta2,u_approx));
      u_approx2:=simplify(subs(tmp2,u_approx2)):
   end if:
   u_approx:=collect(combine(u_approx),cos);
   u_approx2:=collect(combine(u_approx2),cos);
##$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$ 
  error_analy:=simplify(subs(omega=w_approx,INFO("eq2"))): 
  if INFO("podd") mod 2=0 then
     error_analy:=simplify(subs(delta=delta_approx,error_analy)): 
  end if:
  tmp:=collect(u_approx,cos);
   error_analy:=collect(combine(subs(u(tau)=tmp,error_analy)),cos): 
   error_square:=collect(combine(expand(evalf(error_analy)^2)),cos); 
   int_err_square:=int((error_square),tau=0..2*Pi)/(2*Pi);
   #$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
   derror:={diff(int_err_square,h)};
   min_h:={fsolve(derror,h)};
   min_set:={};
   for ij from 1 to nops(min_h) do
      if rhs(op(1,op(ij,min_h)))>-2 and rhs(op(1,op(ij,min_h)))<1 then
          min_set:=min_set union {op(ij,min_h)};
      end if:
   end do:
   min_h:=min_set;
   poss:=1;
   minerr:=simplify(subs(op(1,min_h),int_err_square)):
   for ij from 2 to nops(min_h) do
        ptm:=simplify(subs(op(ij,min_h),int_err_square)):
        if ptm<minerr then
           poss:=ij;
           minerror:=ptm;
        end if:
   end do:
   min_h:=op(poss,min_h);
  ##$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
  printf("The optimal value of h:  %a\n", min_h);
  INFO("w_set"):=Know_w2;
  INFO("w_set"):=simplify(subs(min_h,INFO("w_set")));
  if INFO("podd") mod 2=0 then
    INFO("delta_set"):=Know_delta2;
    INFO("delta_set"):=simplify(subs(min_h,INFO("delta_set")));
  end if:
  tmp:=simplify(subs(INFO("w_set"),Know_u));
  if INFO("podd") mod 2=0 then
     tmp:=simplify(subs(INFO("delta_set"),tmp)):
  end if:
  INFO("u_set"):=tmp;
  INFO("u_set"):=simplify(subs(min_h,INFO("u_set")));
  INFO("Know_h"):=min_h; 
  INFO("w_app"):=[];
  INFO("delta_app"):=[];
  for ij from 1 to nops(INFO("w_set")) do
    if ij=1 then 
      INFO("w_app"):=[op(1,INFO("w_set"))];
    else
      INFO("w_app"):=[op(INFO("w_app")),op(nops(INFO("w_app")),INFO("w_app"))+op(ij,INFO("w_set"))];
    end if:
  end do:
  if INFO("podd") mod 2=0 then
    for ij from 1 to nops(INFO("delta_set")) do
      if ij=1 then 
         INFO("delta_app"):=[op(1,INFO("delta_set"))];
      else
         tmp1:=INFO("delta_app"):
         INFO("delta_app"):=[op(INFO("delta_app")),op(nops(tmp1),tmp1)+op(ij,INFO("delta_set"))];
      end if:
    end do:  
  end if:
  now_t:=time();
  INFO("htime"):=now_t-(INFO("fcomput_t")+INFO("start_t"));
  if INFO("podd") mod 2<>0 then
    conti_odd();
  else
    conti_even();
  end if:
  now_t:=time();
  printf("It takes about %.3f seconds to complete the second part computation.\n\n",now_t-(INFO("htime")+INFO("fcomput_t")+INFO("start_t")));
  Know_u:=INFO("u_set");
  Know_omega:=INFO("w_set");
  Know_delta:=INFO("delta_set");
  Pade_omega:=INFO("w_pade");
  Pade_delta:=INFO("delta_pade");
  printf("The total time is:%.3f seconds.\n",time()-INFO("start_t"));
end proc:
##################################################################################################################

##################### the proc of continue to higher-order of odd oscillation ####################################
conti_odd:=proc() 
local i,j,ij,p11,q11,rhigh,w_eq,w_sol,rhigh_list,rhighn,rhighd,high_eq,sol_list,sol1,sol2,solu,terp,term,cos_term,
      cos_coeff,mp1,tmp,tmp1,tmp2,tt,pp1,w_pade,pade_numer,pade_denom,varset;
 for i from INFO("horder")+1 to INFO("solorder") do
    INFO("R")[i]:=subs(mm=i,INFO("R")[mm]);
    INFO("p1"):=INFO("p1")+u[i](tau)*q^i;
    INFO("q1"):=INFO("q1")+omega[i-1]*q^(i-1);
    p11:=Phi(tau,q)=INFO("p1");
    q11:=omega(q)=INFO("q1");
    INFO("R")[i]:=simplify(subs(p11,INFO("R")[i]));
    INFO("R")[i]:=simplify(subs(q11,INFO("R")[i]));
    INFO("R")[i]:=value(INFO("R")[i]):
    INFO("R")[i]:=convert(INFO("R")[i],diff):
    INFO("R")[i]:=simplify(subs(q=0,INFO("R")[i]));
    rhigh:=INFO("R")[i]+INFO("Lop")(u[i-1](tau));
    rhigh:=simplify(subs(INFO("w_set"),rhigh)):
    rhigh:=simplify(expand(subs(INFO("u_set"),rhigh))):
    rhigh:=simplify(subs(INFO("Know_h"),rhigh)):
    rhigh:=collect(combine(rhigh),cos);
    w_eq:=coeff(rhigh,cos(tau));
    rhigh:=rhigh-w_eq*cos(tau);
    w_sol:={solve(w_eq,omega[i-1])};
    INFO("w_set"):=INFO("w_set") union {omega[i-1]=op(1,w_sol)};
    tmp1:=INFO("w_app"):
    INFO("w_app"):=[op(tmp1),op(nops(tmp1),tmp1)+op(nops(INFO("w_set")),INFO("w_set"))]:
    rhigh:=simplify(subs(INFO("w_set"),rhigh)):
    rhigh:=collect(combine(evalf(rhigh)),cos):
    solu:=Losinv(rhigh,G);
    solu:=solu+_C1*cos(tau);
    tmp1:=simplify(subs(tau=0,solu)):
    tmp:=solve(tmp1=0,{_C1});
    solu:=u[i](tau)=collect(combine(simplify(subs(tmp,solu))),cos);
    solu:=simplify(subs(INFO("w_set"),solu)):
    INFO("u_set"):=INFO("u_set") union {solu};
    if evalf(abs(rhs(op(nops(INFO("w_app")),INFO("w_app")))-rhs(op(nops(INFO("w_app"))-1,INFO("w_app"))))/rhs(op(nops(INFO("w_app")),INFO("w_app"))))<=1.0e-15 then
        INFO("solorder"):=i;  
        break;
    end if:
 end do: 
 INFO("u_set"):=sort(INFO("u_set"),length):
 tmp1:={op(1,INFO("u_set"))}:
 for j from 2 to nops(INFO("u_set"))-3 do
    tmp1:=tmp1 union {op(j,INFO("u_set"))};
 end do:
#&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
 while evalb(INFO("pade_order")<=(nops(INFO("w_set"))-1)/2) do
    pp1:=[];
    for ij from 1 to 2*INFO("pade_order")+1 do 
         pp1:=[op(pp1),rhs(op(ij,INFO("w_set")))];
    end do:
    tmp:=op(1,pp1);
    for ij from 2 to nops(pp1) do
       tmp:=tmp + op(ij,pp1)*q^(ij-1);
    end do:
    pade_numer:=omega[0];
    varset:={omega[0]};
    for j from 1 to INFO("pade_order") do
      pade_numer:=pade_numer + omega[j]*q^j;
      varset:= varset union {omega[j]};
    end do:
    pade_denom:=1;
    for j from 1 to INFO("pade_order") do
       pade_denom:=pade_denom+omega[INFO("pade_order")+1+j]*q^j;
       varset:=varset union {omega[INFO("pade_order")+1+j]};
    end do:
    tmp2:=collect(combine(expand(tmp*(pade_denom)-pade_numer)),q);
    tmp:={tcoeff(tmp2,q)};
    for j from 1 to 2*INFO("pade_order") do
      tmp:=tmp union {coeff(tmp2,q^j)};
    end do;
   tmp2:=solve(tmp,varset);
   pade_numer:=simplify(subs(q=1,pade_numer));
   pade_denom:=simplify(subs(q=1,pade_denom));
   tmp:=simplify(subs(tmp2,pade_numer))/simplify(subs(tmp2,pade_denom));
   INFO("w_pade"):=[op(INFO("w_pade")),tmp];
   INFO("pade_order"):=INFO("pade_order")+1;
 end do:
#&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
 sol1:=add(rhs(ij),ij in tmp1):
 sol2:=add(rhs(ij),ij in INFO("u_set")):
 w_val:=op(nops(INFO("w_pade")),INFO("w_pade"));
 u_exp1:=simplify(subs(tau=w_val*t,sol1));
print("u_approximant=",u_exp1);
 u_exp2:=simplify(subs(tau=w_val*t,sol2));
 tmp1:=plot(u_exp1,t=0..4*Pi, style=line,color=blue): 
 tmp2:=plot(u_exp2,t=0..4*Pi, style=point,color=red):
 ttmp1:=op(1,op(1,tmp1)):
 ttmp2:=op(1,op(1,tmp2)):
 print("graph data:", nops(ttmp1), nops(ttmp2));
 for ti from 1 to nops(ttmp1) do
    if (ti mod 2)<>0 then
         printf("   %.6f         %.6f\n", op(1,op(ti,ttmp1)),op(2,op(ti,ttmp1)));
    end if:
 end do:
 printf("\n\n");
 for ti from 1 to nops(ttmp2) do
    if (ti mod 2)=0 then
       printf("   %.6f         %.6f\n", op(1,op(ti,ttmp2)),op(2,op(ti,ttmp2)));
    end if:
 end do:
 print(display({tmp1,tmp2},title=`The (n-3)th-order u_approx(point) & 
the nth-order u_approx(line)`)); 
 if i<=INFO("solorder") then
   printf("where: n=%d.\n",i); 
 else
   printf("where: n=%d.\n",i-1); 
 end if:
 printf("The approx of w and the corresponding errors:\n"); 
 printf("      ------------------------------------------\n"): 
 printf("      |  i        \omega_{i}            errors    \n"):
 for ij from 1 to  nops(INFO("w_app")) do
    printf("      |------------------------------------------\n"):
   if ij<=10 then
    if ij=1 then
         printf("      |  %d      %.4f        %10s     \n",ij-1,   evalf(rhs(op(ij,INFO("w_app")))), "------"  );
    else
         printf("      |  %d      %.4f          %.4f   \n",ij-1,   evalf(rhs(op(ij,INFO("w_app")))),    evalf((abs(rhs(op(ij,INFO("w_app"))))-abs(rhs(op(ij-1,INFO("w_app")))))/max(10^(-8),abs(rhs(op(ij,INFO("w_app")))))));
    end if:
   else
     printf("      |  %d       %.4f        %.4f   \n",ij-1,  evalf(rhs(op(ij,INFO("w_app")))),    evalf((abs(rhs(op(ij,INFO("w_app"))))-abs(rhs(op(ij-1,INFO("w_app")))))/max(10^(-8),abs(rhs(op(ij,INFO("w_app")))))));
   end if:
end do: 
 printf(" 
       ------------------------------------------\n"): 

printf("\n");
printf("The approx of [pade]\omega and the corresponding errors:\n"); 
 printf("      
       ------------------------------------------\n"): 
 printf("      |  i       [pade]\omega_{i}     errors       \n"):
 for ij from 1 to  nops(INFO("w_pade")) do
    printf("      |------------------------------------------\n"):
   if ij<=10 then
     if ij=1 then
        if type(evalf((op(ij,INFO("w_pade")))),{integer,float}) then
             printf("      |  %d      %.4f       %10s      \n",ij,   evalf((op(ij,INFO("w_pade")))),  "------");
        else
             printf("      |  %d       %10s         %10s   \n",ij,  "------",   "------");
        end if:
     else 
         if type(evalf((op(ij-1,INFO("w_pade")))),{integer,float}) and type(evalf((op(ij,INFO("w_pade")))),{integer,float}) then
             printf("      |  %d      %.4f        %.4f     \n",ij,  evalf((op(ij,INFO("w_pade")))),    evalf((abs(op(ij,INFO("w_pade")))-abs(op(ij-1,INFO("w_pade"))))/max(10^(-8),abs(op(ij,INFO("w_pade"))))));
         else
             printf("      |  %d      %10s         %10s   \n",ij,  "------", "------");
         end if:
     end if:
  else
     if type(evalf((op(ij-1,INFO("w_pade")))),{integer,float}) and type(evalf((op(ij,INFO("w_pade")))),{integer,float}) then
       printf("      |  %d     %.4f        %.4f     \n",ij, evalf((op(ij,INFO("w_pade")))),    evalf((abs(op(ij,INFO("w_pade")))-abs(op(ij-1,INFO("w_pade"))))/max(10^(-8),abs(op(ij,INFO("w_pade"))))));
     else
       printf("      |  %d     %10s         %10s   \n",ij,  "------",  "------");  
     end if:
   end if:
end do: 
 printf(" 
       ------------------------------------------\n"):
end proc:
#################################################################################################################

############################### continue to higher-order approx of quadratic oscillation ########################
conti_even:=proc() 
local 
i,j,ij,p11,q11,rhigh,w_eq,w_sol,rhigh_list,rhighn,rhighd,high_eq,rnumer,rdenom,nu_cbine,delta_eq, 
sol_list,sol1,sol2,solu,terp,term,cos_term,cos_coeff,mp1,tmp,tmp1,tmp2,d11,delta_sol,pp1,pp2,pmt,pmt2,
pade_numer1,pade_numer2,pade_denom1,pade_denom2,varset1,varset2; 
for i from INFO("horder")+1 to INFO("solorder") do
    INFO("R")[i]:=subs(mm=i,INFO("R")[mm]);
    INFO("p1"):=INFO("p1")+u[i](tau)*q^i;
    INFO("q1"):=INFO("q1")+omega[i-1]*q^(i-1);
    INFO("d1"):=INFO("d1")+delta[i-1]*q^(i-1);
    p11:=Phi(tau,q)=INFO("p1");
    q11:=omega(q)=INFO("q1");
    d11:=delta(q)=INFO("d1");
    INFO("R")[i]:=simplify(subs(p11,INFO("R")[i]));
    INFO("R")[i]:=simplify(subs(q11,INFO("R")[i]));
    INFO("R")[i]:=simplify(subs(d11,INFO("R")[i])):
    INFO("R")[i]:=value(INFO("R")[i]):
    INFO("R")[i]:=convert(INFO("R")[i],diff):
    INFO("R")[i]:=simplify(subs(q=0,INFO("R")[i]));
    rhigh:=INFO("R")[i]+INFO("Lop")(u[i-1](tau));
    rhigh:=simplify(subs(INFO("w_set"),rhigh)):
    rhigh:=simplify(expand(subs(INFO("u_set"),rhigh))):
    rhigh:=simplify(subs(INFO("delta_set"),rhigh)):
    rhigh:=simplify(subs(INFO("Know_h"),rhigh)):
    rhigh:=collect(combine(rhigh),cos);
    w_eq:=coeff(rhigh,cos(tau));
    rnumer:=numer(rhigh);
    rdenom:=denom(rhigh);
    nu_cbine:=collect(combine(rnumer),cos);
    delta_eq:=remove(has,nu_cbine,cos);
    rhigh:=rhigh-w_eq*cos(tau)-delta_eq/rdenom;
    rhigh:=collect(combine(rhigh),cos);
    if has(delta_eq,delta[i-1]) then
      w_sol:={solve(w_eq,omega[i-1])};
      delta_sol:={solve(delta_eq,delta[i-1])};
      delta_sol:=remove(has,delta_sol,I);
    else
       tmp:=solve({w_eq,delta_eq},{omega[i-1],delta[i-1]});
       w_sol:=select(has,tmp,omega[i-1]);
       delta_sol:=remove(has,tmp,omega[i-1]);
       if hastype(w_sol,`RootOf`) then
          w_sol:=convert(w_sol,radical);
       end if:
       w_sol:=map(i->rhs(i),w_sol);
       delta_sol:=map(i->rhs(i),delta_sol);
    end if:  
    INFO("w_set"):=INFO("w_set") union {omega[i-1]=op(1,w_sol)};
    INFO("delta_set"):=INFO("delta_set") union {delta[i-1]=op(1,delta_sol)};
    tmp1:=INFO("w_app"):
    tmp2:=simplify(subs(INFO("delta_set"),op(1,w_sol))):
    tmp:={omega[i-1]=tmp2}:
    INFO("w_app"):=[op(tmp1),op(nops(tmp1),tmp1)+op(1,tmp)]:
    tmp1:=INFO("delta_app"):
    tmp2:=simplify(subs(INFO("delta_set"),op(1,delta_sol))):
    tmp:={delta[i-1]=tmp2}:
    INFO("delta_app"):=[op(tmp1),op(nops(tmp1),tmp1)+op(1,tmp)]:
    rhigh:=simplify(subs(omega[i-1]=op(1,w_sol),rhigh)):
    rhigh:=simplify(subs(delta[i-1]=op(1,delta_sol),rhigh)):
    rhigh:=collect(combine(evalf(rhigh)),cos):
    solu:=Losinv(rhigh,G);
    solu:=solu+_C1*cos(tau);
    tmp1:=simplify(subs(tau=0,solu)):
    tmp:=solve(tmp1=0,{_C1});
    solu:=u[i](tau)=collect(combine(simplify(subs(tmp,solu))),cos);
    solu:=simplify(subs(INFO("w_set"),solu)):
    INFO("u_set"):=INFO("u_set") union {solu};
    if evalf(abs(rhs(op(nops(INFO("w_app")),INFO("w_app")))-rhs(op(nops(INFO("w_app"))-1,INFO("w_app"))))/rhs(op(nops(INFO("w_app")),INFO("w_app"))))<=1.0e-15 then
         INFO("solorder"):=i; 
         break;
    end if:
 end do:
 INFO("u_set"):=sort(INFO("u_set"),length):
 tmp1:={op(1,INFO("u_set"))}:
 for j from 2 to nops(INFO("u_set"))-3 do
    tmp1:=tmp1 union {op(j,INFO("u_set"))};
 end do:
 sol1:=add(rhs(ij),ij in tmp1):
 sol2:=add(rhs(ij),ij in INFO("u_set")):
 tmp1:=simplify(subs(INFO("delta_set"),INFO("w_set"))):
 tmp2:=simplify(subs(INFO("w_set"),INFO("delta_set"))):
 INFO("w_set"):=tmp1:
 INFO("delta_set"):=tmp2:
#&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
 while evalb(INFO("pade_order")<=(nops(INFO("w_set"))-1)/2) do
    pp1:=[];
    for ij from 1 to 2*INFO("pade_order")+1 do 
         pp1:=[op(pp1),rhs(op(ij,INFO("w_set")))];
    end do:
    pp2:=[];
    for ij from 1 to 2*INFO("pade_order")+1 do 
         pp2:=[op(pp2),rhs(op(ij,INFO("delta_set")))];
    end do:
    #print("000",pp2);
    tmp:=op(1,pp1);
    for ij from 2 to nops(pp1) do
       tmp:=tmp + op(ij,pp1)*q^(ij-1);
    end do:
    pmt:=op(1,pp2);
    for ij from 2 to nops(pp2) do
       pmt:=pmt + op(ij,pp2)*q^(ij-1);
    end do:
    pade_numer1:=omega[0];
    varset1:={omega[0]};
    pade_numer2:=delta[0];
    varset2:={delta[0]};
    for j from 1 to INFO("pade_order") do
      pade_numer1:=pade_numer1 + omega[j]*q^j;
      varset1:= varset1 union {omega[j]};
    end do:
    for j from 1 to INFO("pade_order") do
      pade_numer2:=pade_numer2 + delta[j]*q^j;
      varset2:= varset2 union {delta[j]};
    end do:
    pade_denom1:=1;
    for j from 1 to INFO("pade_order") do
       pade_denom1:=pade_denom1+omega[INFO("pade_order")+1+j]*q^j;
       varset1:=varset1 union {omega[INFO("pade_order")+1+j]};
    end do:
    pade_denom2:=1;
    for j from 1 to INFO("pade_order") do
       pade_denom2:=pade_denom2+delta[INFO("pade_order")+1+j]*q^j;
       varset2:=varset2 union {delta[INFO("pade_order")+1+j]};
    end do:
    tmp2:=collect(combine(expand(tmp*(pade_denom1)-pade_numer1)),q);
    pmt2:=collect(combine(expand(pmt*(pade_denom2)-pade_numer2)),q);
    tmp:={tcoeff(tmp2,q)};
    for j from 1 to 2*INFO("pade_order") do
      tmp:=tmp union {coeff(tmp2,q^j)};
    end do;
    pmt:={tcoeff(pmt2,q)};
    for j from 1 to 2*INFO("pade_order") do
      pmt:=pmt union {coeff(pmt2,q^j)};
    end do;
    tmp2:=solve(tmp,varset1 intersect indets(tmp));
    pmt2:=solve(pmt,varset2 intersect indets(pmt));
    pade_numer1:=simplify(subs(q=1,pade_numer1));
   pade_denom1:=simplify(subs(q=1,pade_denom1));
   tmp:=simplify(subs(tmp2,pade_numer1))/simplify(subs(tmp2,pade_denom1));
   pade_numer2:=simplify(subs(q=1,pade_numer2));
   pade_denom2:=simplify(subs(q=1,pade_denom2));
   pmt:=simplify(subs(pmt2,pade_numer2))/simplify(subs(pmt2,pade_denom2));
   INFO("w_pade"):=[op(INFO("w_pade")),tmp];
   INFO("delta_pade"):=[op(INFO("delta_pade")),pmt];
   INFO("pade_order"):=INFO("pade_order")+1;
 end do:
#&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
 w_val:=op(nops(INFO("w_pade")),INFO("w_pade"));
 del_val:=op(nops(INFO("delta_pade")),INFO("delta_pade"));
 u_exp1:=simplify(subs(tau=w_val*t,sol1))+del_val;
 u_exp2:=simplify(subs(tau=w_val*t,sol2))+del_val;
 tmp1:=plot(u_exp1,t=0..4*Pi, style=line,color=blue): 
 tmp2:=plot(u_exp2,t=0..4*Pi, style=point,color=red):
 ttmp1:=op(1,op(1,tmp1)):
 ttmp2:=op(1,op(1,tmp2)):
 print("graph data:", nops(ttmp1), nops(ttmp2));
  for ti from 1 to nops(ttmp1) do
     if (ti mod 2)<>0 then
         printf("   %.6f         %.6f\n", op(1,op(ti,ttmp1)),op(2,op(ti,ttmp1)));
     end if:
  end do:
  printf("\n\n");
  for ti from 1 to nops(ttmp2) do
     if (ti mod 2)=0 then
         printf("   %.6f         %.6f\n", op(1,op(ti,ttmp2)),op(2,op(ti,ttmp2)));
     end if:
  end do:
  print(display({tmp1,tmp2}, title=`The (n-3)th-order u_approx(point) 
 & the nth-order u_approx(line)`)); 

 if i<=INFO("solorder") then
     printf("where: n=%d.\n",i); 
 else
     printf("where: n=%d.\n",i-1); 
 end if:
 printf("The homotopy approximants and the corresponding errors:\n"); 
 printf("      
       ------------------------------------------------------------------\n"): 
 printf("      |  i      \omega_{i}       errors        \delta_{i}       errors     \n"):
 for ij from 1 to  nops(INFO("w_app")) do
    printf("      |------------------------------------------------------------------\n"):
   if ij<=10 then
      if ij=1 then
         printf("      |  %d    %.4f    %10s      %.4f     %10s    \n",ij-1,    evalf(rhs(op(ij,INFO("w_app")))),    "------",  evalf(rhs(op(ij,INFO("delta_app")))),    "------");
      else
        printf("      |  %d    %.4f     %.4f     %.4f     %.4f    \n",ij-1,    evalf(rhs(op(ij,INFO("w_app")))),    evalf((abs(rhs(op(ij,INFO("w_app"))))-abs(rhs(op(ij-1,INFO("w_app")))))/max(10^(-8),abs(rhs(op(ij,INFO("w_app")))))), evalf(rhs(op(ij,INFO("delta_app")))),    evalf((abs(rhs(op(ij,INFO("delta_app"))))-abs(rhs(op(ij-1,INFO("delta_app")))))/max(10^(-8),abs(rhs(op(ij,INFO("delta_app")))))));
      end if:
   else
    printf("      |  %d   %.4f     %.4f     %.4f     %.4f    \n",ij-1,     evalf(rhs(op(ij,INFO("w_app")))),    evalf((abs(rhs(op(ij,INFO("w_app"))))-abs(rhs(op(ij-1,INFO("w_app")))))/max(10^(-8),abs(rhs(op(ij,INFO("w_app")))))), evalf(rhs(op(ij,INFO("delta_app")))),    evalf((abs(rhs(op(ij,INFO("delta_app"))))-abs(rhs(op(ij-1,INFO("delta_app")))))/max(10^(-8),abs(rhs(op(ij,INFO("delta_app")))))));
   end if:
 end do: 
 printf(" 
       ------------------------------------------------------------------\n"): 
 printf("\n");
 printf("The homotopy-Pade approximants and the corresponding errors:\n"); 
 printf("      
       ------------------------------------------------------------------\n"): 
 printf("      |  i    \omega[pade][i,i]    errors     \delta[pade][i,i]  errors     \n"):
 for ij from 1 to  nops(INFO("w_pade")) do
    printf("      |------------------------------------------------------------------\n"):
   if ij<10 then
      if ij=1 then
         if type(evalf((op(ij,INFO("w_pade")))),{integer,float}) and  type(evalf((op(ij,INFO("delta_pade")))),{integer,float}) then
             printf("      |  %d    %.4f      %10s     %.4f    %10s    \n",ij,    evalf((op(ij,INFO("w_pade")))),   "------",  evalf((op(ij,INFO("delta_pade")))),   "------");
         elif  type(evalf((op(ij,INFO("w_pade")))),{integer,float}) then
             printf("      |  %d    %.4f      %10s     %10s    %10s    \n",ij,    evalf((op(ij,INFO("w_pade")))),   "------",  "------",   "------");
         elif  type(evalf((op(ij,INFO("delta_pade")))),{integer,float}) then
             printf("      |  %d    %10s      %10s     %.4f    %10s    \n",ij,     "------",   "------",  evalf((op(ij,INFO("delta_pade")))),   "------");
         else
             printf("      |  %d   %10s      %10s     %10s    %10s     \n",ij,  "------",  "------","------",  "------");
         end if:  
     else
        if evalb(type(evalf((op(ij-1,INFO("w_pade")))),{integer,float}) and type(evalf((op(ij,INFO("w_pade")))),{integer,float}) and type(evalf((op(ij-1,INFO("delta_pade")))),{integer,float}) and type(evalf((op(ij,INFO("delta_pade")))),{integer,float}) ) then
             printf("      |  %d    %.4f       %.4f     %.4f    %.4f   \n",ij, evalf((op(ij,INFO("w_pade")))),    evalf((abs((op(ij,INFO("w_pade"))))-abs(op(ij-1,INFO("w_pade"))))/max(10^(-8),abs(op(ij,INFO("w_pade"))))),evalf((op(ij,INFO("delta_pade")))),    evalf((abs((op(ij,INFO("delta_pade"))))-abs(op(ij-1,INFO("delta_pade"))))/max(10^(-8),abs(op(ij,INFO("delta_pade"))))));
        elif evalb(type(evalf((op(ij-1,INFO("w_pade")))),{integer,float}) and type(evalf((op(ij,INFO("w_pade")))),{integer,float})) then
             printf("      |  %d    %.4f       %.4f     %10s    %10s   \n",ij, evalf((op(ij,INFO("w_pade")))),    evalf((abs((op(ij,INFO("w_pade"))))-abs(op(ij-1,INFO("w_pade"))))/max(10^(-8),abs(op(ij,INFO("w_pade"))))),"------",   "------");
        elif evalb(type(evalf((op(ij-1,INFO("delta_pade")))),{integer,float}) and type(evalf((op(ij,INFO("delta_pade")))),{integer,float})) then
             printf("      |  %d    %10s       %10s     %.4f    %.4f   \n",ij,  "------",  "------",evalf((op(ij,INFO("delta_pade")))),    evalf((abs((op(ij,INFO("delta_pade"))))-abs(op(ij-1,INFO("delta_pade"))))/max(10^(-8),abs(op(ij,INFO("delta_pade"))))));
        else
             printf("      |  %d   %10s       %10s     %10s    %10s    \n",ij,   "------", "------", "------", "------");
        end if:
    end if:
 else
       if type(evalf((op(ij-1,INFO("w_pade")))),{integer,float}) and type(evalf((op(ij,INFO("w_pade")))),{integer,float}) and type(evalf((op(ij-1,INFO("delta_pade")))),{integer,float}) and type(evalf((op(ij,INFO("delta_pade")))),{integer,float})  then
             printf("      |  %d   %.4f       %.4f     %.4f    %.4f   \n",ij, evalf((op(ij,INFO("w_pade")))),    evalf((abs(op(ij,INFO("w_pade")))-abs(op(ij-1,INFO("w_pade"))))/max(10^(-8),abs(op(ij,INFO("w_pade"))))),evalf((op(ij,INFO("delta_pade")))),    evalf((abs(op(ij,INFO("delta_pade")))-abs(op(ij-1,INFO("delta_pade"))))/max(10^(-8),abs(op(ij,INFO("delta_pade"))))));
        elif type(evalf((op(ij-1,INFO("w_pade")))),{integer,float}) and type(evalf((op(ij,INFO("w_pade")))),{integer,float}) then
             printf("      |  %d   %.4f       %.4f     %10s    %10s   \n",ij, evalf((op(ij,INFO("w_pade")))),    evalf((abs(op(ij,INFO("w_pade")))-abs(op(ij-1,INFO("w_pade"))))/max(10^(-8),abs(op(ij,INFO("w_pade"))))),"------",   "------");
        elif  type(evalf((op(ij-1,INFO("delta_pade")))),{integer,float}) and type(evalf((op(ij,INFO("delta_pade")))),{integer,float}) then
             printf("      |  %d   %10s       %10s     %.4f    %.4f   \n",ij,  "------",  "------",evalf((op(ij,INFO("delta_pade")))),    evalf((abs(op(ij,INFO("delta_pade")))-abs(op(ij-1,INFO("delta_pade"))))/max(10^(-8),abs(op(ij,INFO("delta_pade"))))));
        else
             printf("      |  %d  %10s       %10s     %10s    %10s    \n",ij,  "------", "------", "------", "------");
        end if:
   end if:
end do: 
printf("      
       ------------------------------------------------------------------\n"): 
end proc:
##################################################################################################################

end module: 

